//---------------------------------------------------------------------------
// project1
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "io.h"
#include "dir.h"
#include "process.h"
#include "stdio.h"
#include "dos.h"
#include "memory.h"
#include "stdlib.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WriteIni()
{
  HKEY hKey;
  RegCreateKeyA(HKEY_LOCAL_MACHINE,"Software\\KasperskyLab\\AVPVX",&hKey);
#define w1(x,y)  { int i=x->Checked; RegSetValueExA(hKey,y,0,REG_DWORD,(unsigned char*)&i,4); };
#define w2(x,y)  { char*s=strdup(x->Text.c_str()); RegSetValueExA(hKey,y,0,REG_SZ,s,strlen(s)+1); };
  w1(CheckBox1,"cb1");
  w1(CheckBox2,"cb2");
  w1(CheckBox3,"cb3");
  w1(CheckBox4,"cb4");
  w1(CheckBox5,"cb5");
  w1(CheckBox6,"cb6");
  w1(CheckBox7,"cb7");
  w1(CheckBox8,"cb8");
  w1(CheckBox9,"cb9");
  w2(Edit1,"e1");
  w2(Edit2,"e2");
  w2(Edit3,"e3");
  RegCloseKey(hKey);
}

void __fastcall TForm1::ReadIni()
{
  HKEY hKey;
  RegCreateKeyA(HKEY_LOCAL_MACHINE,"Software\\KasperskyLab\\AVPVX",&hKey);
  unsigned long j=4;
#define r1(x,y)  { int i=0; j=4; if (RegQueryValueExA(hKey,y,0,&j,(unsigned char*)&i,&j)==ERROR_SUCCESS) x->Checked=i; };
#define r2(x,y)  { j=256; char* s=(char*)malloc(256); strcpy(s,"<empty>");  if (RegQueryValueExA(hKey,y,0,&j,s,&j)==ERROR_SUCCESS) x->Text=s; };
  r1(CheckBox1,"cb1");
  r1(CheckBox2,"cb2");
  r1(CheckBox3,"cb3");
  r1(CheckBox4,"cb4");
  r1(CheckBox5,"cb5");
  r1(CheckBox6,"cb6");
  r1(CheckBox7,"cb7");
  r1(CheckBox8,"cb8");
  r1(CheckBox9,"cb9");
  r2(Edit1,"e1");
  r2(Edit2,"e2");
  r2(Edit3,"e3");
  RegCloseKey(hKey);
}


void __fastcall TForm1::Check1()
{
  int i=1;

  if (access(Edit1->Text.c_str(),4)!=0)
  {
    Edit1->Font->Color=clRed;
    i=0;
  }
  else
    Edit1->Font->Color=clWindowText;

  if (access(Edit2->Text.c_str(),0)!=0)
  {
    Edit2->Font->Color=clRed;
    BitBtn2->Enabled=0;
  }
  else
  {
    Edit2->Font->Color=clWindowText;
    BitBtn2->Enabled=1;
  }

  if (access(Edit3->Text.c_str(),0)!=0)
  {
    Edit3->Font->Color=clRed;
    i=0;
  }
  else
    Edit3->Font->Color=clWindowText;

  BitBtn1->Enabled=i;
}

void __fastcall TForm1::CopyDir()
{
  if (!CheckBox8->Checked) return;
  char s[512];
  strcpy(s,Edit1->Text.c_str());
  if (strrchr(s,'.')) *strrchr(s,'.')=0;
  if (s[0]!=0) strcat(s,"\\");
  Edit2->Text=s;
}

void __fastcall TForm1::Open1()
{
  if (OpenDialog1->Execute())
  {
    Edit1->Text=OpenDialog1->FileName;
    CopyDir();
  }
  Check1();
}

void __fastcall TForm1::erase1()
{
  char s[512],q[512];
  strcpy(s,Edit2->Text.c_str());
  if (s[strlen(s)-1]!='\\') strcat(s,"\\");
  strcpy(q,s);
  strcat(s,"*.*");
                             // messageboxa
  if (Application->MessageBox(s,"Erase?", MB_YESNO)!=IDYES) return;

  struct ffblk ffblk;
  for (int done=findfirst(s,&ffblk,FA_ARCH|FA_DIREC);
       !done;
       done=findnext(&ffblk))
  {
    if  (!(ffblk.ff_attrib&FA_DIREC))
    {
      strcpy(s,q);
      strcat(s,ffblk.ff_name);
      remove(s);
    }
  }

  strcpy(s,Edit2->Text.c_str());
  if (s[strlen(s)-1]=='\\') s[strlen(s)-1]=0;
  rmdir(s);

  Check1();
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{
  Open1();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn5Click(TObject *Sender)
{
  if (OpenDialog3->Execute())
    Edit3->Text=OpenDialog3->FileName;
  Check1();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox7Click(TObject *Sender)
{
  if (CheckBox7->Checked)
  {
    CheckBox1->Enabled=0;
    CheckBox2->Enabled=0;
    CheckBox3->Enabled=0;
    CheckBox4->Enabled=0;
    CheckBox5->Enabled=0;
    CheckBox6->Enabled=0;
  }
  else
  {
    CheckBox1->Enabled=1;
    CheckBox2->Enabled=1;
    CheckBox3->Enabled=1;
    CheckBox4->Enabled=1;
    CheckBox5->Enabled=1;
    CheckBox6->Enabled=1;
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
  char s[512],q[512];
  strcpy(s,Edit3->Text.c_str());
  strcpy(q,"\x22");
  strcat(q,Edit1->Text.c_str());
  strcat(q,"\x22 \x22");
  strcat(q,Edit2->Text.c_str());
  if (q[strlen(q)-1]=='\\')
      q[strlen(q)-1]=0;
  strcat(q,"\x22");

  if (CheckBox7->Checked)
  {
    strcat(q," /names");
  }
  else
  {
    if (!CheckBox1->Checked) strcat(q," /no16");
    if (!CheckBox2->Checked) strcat(q," /no32");
    if ( CheckBox3->Checked) strcat(q," /l");
    if ( CheckBox4->Checked) strcat(q," /k");
    if (!CheckBox5->Checked) strcat(q," /nh");
    if (!CheckBox6->Checked) strcat(q," /ns");
  }
  if (CheckBox9->Checked)
    strcat(q," /qq");
  else
    strcat(q," /p");

  int res = spawnlp(P_WAIT,s,s,q,0);

  if (res!=0)
    Application->MessageBox(
      "Error executing AVPX","Error",0);
  else
    Application->MessageBox(
      "AVPX executed","Information",0);

  Check1();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Edit1Change(TObject *Sender)
{
  CopyDir();
  Check1();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit2Change(TObject *Sender)
{
  Check1();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit3Change(TObject *Sender)
{
  Check1();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox8Click(TObject *Sender)
{
  if (CheckBox8->Checked)
  {
    Edit2->Enabled=0;
    Edit2->Color=clBtnFace;
    CopyDir();
  }
  else
  {
    Edit2->Enabled=1;
    Edit2->Color=clWindow;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
  erase1();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
WriteIni();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
  ReadIni();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::BitBtn4Click(TObject *Sender)
{
  WriteIni();
  Application->Terminate();
}
//---------------------------------------------------------------------------
